########## Problem 1.1

### 1.
demographics <- read.csv("demographics-synthetic.csv")

getmode <- function(v) {
  uniqv <- unique(v)
  uniqv[which.max(tabulate(match(v, uniqv)))]
}

mean(demographics$Age)
median(demographics$Age)
getmode(demographics$Age)


### 2.
demographics <- demographics[-c(333, 400, 217, 242, 259, 327, 337), ]
nrow(demographics)


### 3.
mean(demographics$Age)
median(demographics$Age)
getmode(demographics$Age)


### 4.
var(demographics$Height)
var(demographics$Weight)


### 5.
quantile(demographics$Age, probs=0.18)


### 6.
plot(demographics$Weight, demographics$Age)


### 7.
plot(demographics$Weight, demographics$Age, xlab="Weight", ylab="Age",
     col="red", main="Scatterplot of Weight and Age")


### 8.
abline(h=30)
abline(v=90)


### 9.
plot(demographics$Gender, demographics$Age)


### 10.
par(mfrow=c(1, 2))
plot(demographics$Weight, demographics$Age, xlab="Weight", ylab="Age",
     col="red", main="Scatterplot of Weight and Age")
plot(demographics$Gender, demographics$Age)


### 11.
hist(demographics$Weight, breaks="FD")




########## Problem 1.2

### 1.
voting <- read.csv("voting-demo.csv")
nrow(voting)
ncol(voting)


### 3.
summary(voting)

which(is.na(voting$Vote))
which(is.na(voting$Age))
which(is.na(voting$Church))
voting <- voting[-c(94, 239, 335, 602, 649), ]
summary(voting)

getmode <- function(v) {
  uniqv <- unique(v)
  uniqv[which.max(tabulate(match(v, uniqv)))]
}
getmode(voting$Age)

t1 <- table(voting$Choice)
t2 <- transform(t1, cumulative=cumsum(Freq), relative=prop.table(Freq))
t2

library(e1071)
n <- length(voting$Age)  # We first compute the number of observations in Age.
max(voting$Age) - min(voting$Age)  # Range
quantile(voting$Age, probs=0.75) - quantile(voting$Age, probs=0.25)  # IQR
sum(abs(voting$Age - mean(voting$Age))) / n  # MAD
(n - 1)*var(voting$Age) / n  # MSD
var(voting$Age)  # Variance
sd(voting$Age)  # SD
skewness(voting$Age)  # Skewness
kurtosis(voting$Age)  # Kurtosis




########## Problem 1.3

### 1.
create.table <- function(x) {
  tab <- table(x)
  tab <- transform(tab, cumFreq=cumsum(Freq), relative=prop.table(Freq))
  colnames(tab) <- c("Value", "Frequency", "Cum.Freq", "Rel.Freq")
  return(tab)
}

count_frequency <- function(x) {
  counts <- rep(0, times=length(levels(x)))
  names(counts) <- levels(x)
  for (value in x) {
    counts[value] <- counts[value] + 1
  }
  return(counts)
}


### 2.
compute.mean.1 <- function(x) {
  s <- sum(x)
  l <- length(x)
  return(s/l)
}


### 3.
compute.mean.2 <- function(x) {
  l <- 0
  s <- 0
  for (i in x) {
    l <- l+1
    s <- s+i
  }
  return(s/l)
}


### 4.
# Simulate data:
set.seed(631584)
x <- rnorm(10^7, mean=0, sd=1)

# Time compute.mean.1() function:
start.time <- Sys.time()
compute.mean.1(x)
end.time <- Sys.time()
end.time - start.time

# Time compute.mean.2() function:
start.time <- Sys.time()
compute.mean.2(x)
end.time <- Sys.time()
end.time - start.time


### 5.
set.seed(631584)
x <- rnorm(100, mean=0, sd=1)
length(x)


### 6.
summary(x)
sd(x)


### 7.
plot(density(x))


### 8.
set.seed(631584)
x2 <- c(rnorm(1000, mean=0, sd=1), rnorm(1000, mean=4, sd=2))
summary(x2)
sd(x2)
plot(density(x2))




########## Problem 1.4

### 1.
age <- c(30, 23, 29, 36, 68, 32, 32, 23)
mean(age)                                                          # mean
median(age)                                                        # median
xtab <- table(age); as.numeric(names(xtab)[xtab==max(xtab)])       # mode
max(age) - min(age)                                                # range
sum(abs(age-mean(age)))/length(age)                                # MAD
var(age)                                                           # variance
sd(age)                                                            # SD


### 2.
age2 <- age[-5]
mean(age2)                                                         # mean
median(age2)                                                       # median
xtab <- table(age2); as.numeric(names(xtab)[xtab==max(xtab)])      # mode
max(age2) - min(age2)                                              # range
sum(abs(age2-mean(age2)))/length(age2)                             # MAD
var(age2)                                                          # variance
sd(age2)                                                           # SD


### 3.
age_mean <- mean(age)
age_sd <- sd(age)
age_z <- (age - age_mean) / age_sd
age_z
mean(age_z)
sd(age_z)




########## Problem 1.6

# Function to create the data:
createData <- function(n, seed=10) {
  set.seed(seed)
  
  # Create
  gender <- rbinom(n, 1, .48)
  height <- round(170 + gender*10 + rnorm(n, 0, 15), 1)
  weight <- height / 2 + runif(n, -10, 10)
  voting <- rbinom(n, 5, c(.3, .3, .2, .195, .005))
  age <- round(23 + sqrt(rnorm(n, 0, 5)^2), 1)
  
  # Recode
  voting <- ifelse(voting==4, 99, voting)
  gender <- ifelse(gender==1, "Male", "Female")
  
  # Return data frame
  data <- data.frame(
    "Gender" = gender,
    "Age" = age,
    "Weight" = weight,
    "Height" = height,
    "Voting" = voting)
  
  return(data)
}

# Create the data and store it:
n <- 500
data <- createData(n)
write.csv(data, file="Lecture1_Data.csv")


### 1.
set.seed(26078)
rbinom(10, size=1, prob=0.5)
rbinom(10, size=1, prob=0.9)
rbinom(10, size=1, prob=0)
rbinom(10, size=5, prob=0)
rbinom(10, size=5, prob=1)
rbinom(10, size=5, prob=0.5)


### 4.
x <- c(0, 1, 1, 1)
y <- c(1, 0, 1, 0)
ifelse(x==y, yes="Match", no="No match")
