########## Problem 2.1

### 4.
# Method 1:
K_1 <- choose(9, 3)
subset_1 <- sample(1:K_1, size=1)

# Method 2:
K_2 <- 3
subset_2 <- sample(1:K_2, size=1)

# Method 3:
K_3 <- choose(3, 1)*choose(3, 1)*choose(3, 1)
subset_3 <- sample(1:K_3, size=1)


### 5.
# Method 1:
population <- 1:9
sample_1  <- sample(population, size=3, replace=FALSE)
sample_1

# Method 2:
group_1 <- c(1, 2, 3)
group_2 <- c(4, 5, 6)
group_3 <- c(7, 8, 9)
sample_2 <- rep(NA, 3)
sample_2[1] <- sample(group_1, size=1)
sample_2[2] <- sample_2[1] + 3
sample_2[3] <- sample_2[1] + 6  # or sample_2[2] + 3 
sample_2

# Method 3:
sample_3 <- rep(NA, 3)
sample_3[1] <- sample(group_1, size=1)
sample_3[2] <- sample(group_2, size=1)
sample_3[3] <- sample(group_3, size=1)
sample_3




########## Problem 2.2

### 1.
# Recreate data:
school <- 1:6
students <- c(59, 28, 90, 44, 36, 57)
count <- c(4, 5, 3, 3, 7, 8)
data <- as.data.frame(cbind(school, students, count))

# Compute estimators for all possible samples of 3 schools:
samples <- combn(1:6, 3)  # Creates a matrix with 20 columns containing all possible samples.
K <- ncol(samples)
theta <- 30/314
estimators <- rep(NA, K)
for (k in 1:K) {
  sample_school <- samples[, k]
  sample_data <- data[sample_school, ]
  estimators[k] <- sum(sample_data$count)/sum(sample_data$students)
}

# Compute bias, mean square error, and standard error:
bias <- mean(estimators) - theta
MSE <- mean((estimators - theta)^2)
SE <- sqrt(mean((estimators - mean(estimators))^2))
data.frame(bias=bias, MSE=MSE, SE=SE)


### 2.
stratum_1 <- c(1, 3)
stratum_2 <- c(4, 6)
stratum_3 <- c(2, 5)
samples <- t(unname(expand.grid(stratum_1, stratum_2, stratum_3)))  # Creates a matrix with 8 columns containing all possible samples.


### 3.
stratum_1 <- c(1, 2)
stratum_2 <- c(3, 5)
stratum_3 <- c(4, 6)
samples <- t(unname(expand.grid(stratum_1, stratum_2, stratum_3)))


### 5.
# Draw sample:
set.seed(19670912)
sample_school <- sample(data$school, size=3, replace=FALSE)
sample_data <- data[sample_school, ]
sample_imm <- sample_data$count/sample_data$students

# Estimate bias, mean square error, and standard error:
N <- 6
n <- 3
f <- n/N
bias <- mean(sample_imm) - theta
SE <- sqrt(1-f)*sqrt(var(sample_imm))/sqrt(n)
MSE <- SE^2 + bias^2
data.frame(bias=bias, MSE=MSE, SE=SE)




########## Problem 2.3

### 1.
high_school <- read.csv("high-school.csv")

mean(high_school$AGE)
mean(high_school$HEIGHT)
mean(high_school$SPORTS)
mean(high_school$TV)
mean(high_school$COMPUTER)
mean(high_school$ALLOWANCE)
mean(high_school$WORK)

N <- nrow(high_school)
var(high_school$AGE)*(N-1)/N
var(high_school$HEIGHT)*(N-1)/N
var(high_school$SPORTS)*(N-1)/N
var(high_school$TV)*(N-1)/N
var(high_school$COMPUTER)*(N-1)/N
var(high_school$ALLOWANCE)*(N-1)/N
var(high_school$WORK)*(N-1)/N


### 2.
high_school$NOSPRT <- as.numeric(high_school$SPORTS==0)
high_school$NOTV <- as.numeric(high_school$TV==0)
high_school$NOCOMPUTER <- as.numeric(high_school$COMPUTER==0)
mean(high_school$NOSPRT)
mean(high_school$NOTV)  
mean(high_school$NOCOMPUTER)


### 3.
freq_gender <- table(high_school$GENDER)
freq_subject <- table(high_school$SUBJECT)
freq_break <- table(high_school$BREAKFAST)
prop.table(freq_gender)
prop.table(freq_subject)
prop.table(freq_break)


### 4a.
# Draw a simple random sample:
set.seed(19670912)
n <- 1200
sample_Nr <- sample(high_school$Nr, size=n, replace=FALSE)
new_data <- high_school[sample_Nr, ]

# Estimate the means and standard errors (run ?apply for information on the apply() function):
apply(new_data[, c(4:8, 10:11)], 2, mean)
vars <- apply(new_data[, c(4:8, 10:11)], 2, var)
N <- nrow(high_school)
n <- nrow(new_data)
f <- n/N
SE_hat <- sqrt(1-f)*sqrt(vars)/sqrt(n)
SE_hat


### 4b.
prop_nosport <- mean(new_data$NOSPRT)
prop_noTV <- mean(new_data$NOTV)
prop_nocomp <- mean(new_data$NOCOMPUTER)
prop_nosport
prop_noTV
prop_nocomp

SE_nosport <- sqrt(1-f)*sqrt(prop_nosport*(1-prop_nosport))/sqrt(n)
SE_noTV <- sqrt(1-f)*sqrt(prop_noTV*(1-prop_noTV))/sqrt(n)
SE_nocomp  <- sqrt(1-f)*sqrt(prop_nocomp*(1-prop_nocomp))/sqrt(n)
SE_nosport
SE_noTV
SE_nocomp


### 4c.
freq_SexMath <- table(new_data$GENDER, new_data$SUBJECT)

prop_boy <- prop.table(freq_SexMath)[1, 14]
prop_girl <- prop.table(freq_SexMath)[2, 14]
prop_boy
prop_girl

SE_boy <- sqrt(1-f)*sqrt(prop_boy*(1-prop_boy))/sqrt(n)
SE_girl <- sqrt(1-f)*sqrt(prop_girl*(1-prop_girl))/sqrt(n)
SE_boy
SE_girl


### 5b.
# Note that high_school$PROVINCE is coded from 20 to 31, so we recode it from 1 to 12:
high_school$PROV <- high_school$PROVINCE - 19

# Create vectors and matrices for storing the results for 12 provinces and 7 numerical variables:
W_k <- rep(NA, 12)
n_k <- rep(NA, 12)
N_k <- rep(NA, 12)
mean_k <- matrix(NA, nrow=12, ncol=7, dimnames=list(c(), colnames(high_school)[c(4:8, 10:11)]))
var_k <- matrix(NA, nrow=12, ncol=7, dimnames=list(c(), colnames(high_school)[c(4:8, 10:11)]))

# Draw a stratified sample and compute the sample means and variances in each stratum (i.e., province):
N <- nrow(high_school)
n <- 1200  # 1200 is the size of the simple random sample from part (4) above.
set.seed(19670912)
for (i in 1:12) {
  PROVINCE <- high_school[high_school$PROV==i, ]
  N_k[i] <- nrow(PROVINCE)
  W_k[i] <- N_k[i]/N
  n_k[i] <- round(W_k[i]*n)
  
  # Draw random sample from province i:
  PROVINCE$newid <- 1:N_k[i]
  strat_prov <- sample(PROVINCE$newid, size=n_k[i], replace=FALSE)
  sample_prov <- PROVINCE[strat_prov, ]
  
  # Compute means and variances for 7 variables using the sample data from province i:
  mean_k[i, ] <- apply(sample_prov[, c(4:8, 10:11)], 2, mean)
  var_k[i, ] <- apply(sample_prov[, c(4:8, 10:11)], 2, var)
}

means <- apply(W_k*mean_k, 2, sum)
means

var_stra <- (1 - n/N)*W_k*var_k/n
SE_stra  <- sqrt(colSums(var_stra))
SE_stra




########## Problem 2.4

### 1.
# Histogram:
hist(estimators, breaks=30)
abline(v=theta)

# Density plot:
plot(density(estimators))
abline(v=theta)


### 2.
n <- 10
results_10 <- print_summary(theta=theta, estimators=estimators)
estimators_10 <- estimators

n <- 100
results_100 <- print_summary(theta=theta, estimators=estimators)
estimators_100 <- estimators

results_10
results_100

par(mfrow=c(2, 1))
hist(estimators_10, breaks=30)
hist(estimators_100, breaks=30)
plot(density(estimators_10))
plot(density(estimators_100))


### 3.
compute_estimator <- function(x) {
  est <- median(x)
  return(est)
}

results_mean <- print_summary(theta=theta, estimators=estimators)
results_median <- print_summary(theta=theta, estimators=estimators)

results_mean
results_median


### 4.
compute_estimator <- function(x) {
  est <- sum((x - mean(x))^2) / (length(x) - 1)  # Computes the sample variance using n - 1 in the denominator.
  return(est)
}

theta <- sum((P$x - mean(P$x))^2) / length(P$x)  # Computes the population variance using N in the denominator.

hist(estimators, breaks=30)
plot(density(estimators))


### 5.
sample_from_population <- function(P, n) {
  selected_groups <- sample(sort(unique(P$group)), size=n)  # Draw simple random sample of n clusters.
  in_selected_groups <- P$group %in% selected_groups  # Determine which units are in the selected groups.
  selected <- P$i[in_selected_groups]  # Select the units that are in the selected groups.
  return(selected)
}

# Set seed, N, groups, n, and the number of simulations
set.seed(12345)
N <- 1000
groups <- 50
n <- 5
sims <- 100000

# Generate the population data:
P <- generate_population_data(N=N, groups=groups)
