########## Problem 5.1

### 4.
x <- c(0.05, 0.20, 1.72, 0.61, 0.24, 0.79, 0.13, 0.59, 0.26, 0.54)
xbar <- mean(x)
lambdahat <- 1/xbar
lambdahat




########## Problem 5.2

### 1.
library(e1071)
high_school <- read.csv("high-school.csv")
colnames(high_school)  # Print a list of the variable names in high_school.
hs_variable <- high_school$AGE  # Extract variable of interest and store in hs_variable.

n <- nrow(high_school)
mean(hs_variable)
var(hs_variable)
skewness(hs_variable, type=3)
kurtosis(hs_variable, type=3)


### 2.
# Confidence interval for the mean:
lower <- mean(hs_variable) - qnorm(1-0.025, mean=0, sd=1)*sqrt(var(hs_variable)/n)
upper <- mean(hs_variable) + qnorm(1-0.025, mean=0, sd=1)*sqrt(var(hs_variable)/n)
CI_mean <- c(lower, upper)
CI_mean

# Confidence interval for the variance:
lower <- (n-1)*var(hs_variable)/qchisq(0.025, df=n-1, lower.tail=FALSE)
upper <- (n-1)*var(hs_variable)/qchisq(1-0.025, df=n-1, lower.tail=FALSE)
CI_var <- c(lower, upper)
CI_var


### 3.
quantile(hs_variable, probs=0.2)


### 4.
high_school$NOSPORT <- as.numeric(high_school$SPORT==0)  # Create dichotomous variable indicating whether a child sports (NOSPORT = 0) or does not sport (NOSPORT = 1).
prop_nosport <- mean(high_school$NOSPORT)
var_nosport  <- prop_nosport*(1-prop_nosport)
lower <- prop_nosport - qnorm(1-0.025, mean=0, sd=1)*sqrt(var_nosport/n)
upper <- prop_nosport + qnorm(1-0.025, mean=0, sd=1)*sqrt(var_nosport/n)
CI_prop <- c(lower, upper)
CI_prop




########## Problem 5.3

### 1.
set.seed(19680912)
n <- 10
p <- 0.2
SE <- sqrt((p*(1-p)/n))  
nsim <- 10000  # Number of simulations.
stand_samp_ave <- rep(NA, nsim)
for (i in 1:nsim){
  x <- rbinom(n, size=1, prob=p)
  xbar <- mean(x)
  stand_samp_ave[i] <- (xbar-p)/SE
} 
hist(stand_samp_ave, freq=FALSE)
mean(stand_samp_ave)
var(stand_samp_ave)


### 2.
set.seed(19680912)
n <- 10
p <- 0.2
nsim <- 10000
counter <- 0
for (i in 1:nsim) {
  x <- rbinom(n, size=1, prob=p)
  xbar <- mean(x)
  var_x <- xbar*(1-xbar)
  CI_lower <- xbar - qnorm(1-0.025, mean=0, sd=1)*sqrt(var_x/n)
  CI_upper <- xbar + qnorm(1-0.025, mean=0, sd=1)*sqrt(var_x/n)
  if (CI_lower<p & CI_upper>p) counter <- counter+1
} 
counter/nsim


### 3.
set.seed(19680912)
n <- 50
p <- 0.2
SE <- sqrt((p*(1-p)/n))  
nsim <- 10000  # Number of simulations.
stand_samp_ave <- rep(NA, nsim)
for (i in 1:nsim){
  x <- rbinom(n, size=1, prob=p)
  xbar <- mean(x)
  stand_samp_ave[i] <- (xbar-p)/SE
} 
hist(stand_samp_ave, freq=FALSE)
mean(stand_samp_ave)
var(stand_samp_ave)




########## Problem 5.4

### 1.
set.seed(19680912)
n <- 3
lambda <- 0.5
nsim <- 10000
counter <- 0
for (i in 1:nsim) {
  x <- rexp(n, rate=0.5)
  xbar <- mean(x)
  var_x <- var(x)
  CI_lower <- xbar - qnorm(1-0.025, mean=0, sd=1)*sqrt(var_x/n)
  CI_upper <- xbar + qnorm(1-0.025, mean=0, sd=1)*sqrt(var_x/n)
  if (CI_lower<(1/lambda) & CI_upper>(1/lambda)) counter <- counter+1
} 
counter/nsim


### 2.
set.seed(19680912)
n <- 20
lambda <- 0.5
nsim <- 10000
counter <- 0
for (i in 1:nsim) {
  x <- rexp(n, rate=0.5)
  xbar <- mean(x)
  var_x <- var(x)
  CI_lower <- xbar - qnorm(1-0.025, mean=0, sd=1)*sqrt(var_x/n)
  CI_upper <- xbar + qnorm(1-0.025, mean=0, sd=1)*sqrt(var_x/n)
  if (CI_lower<(1/lambda) & CI_upper>(1/lambda)) counter <- counter+1
} 
counter/nsim


### 4.

# Compute CI assuming normality:
set.seed(19680912)
n <- 20
lambda <- 0.5
nsim <- 10000
counter <- 0
for (i in 1:nsim) {
  x <- rexp(n, rate=0.5)
  var_x <- var(x)
  CI_lower <- (n-1)*var_x/qchisq(0.025, df=n-1, lower.tail=FALSE)
  CI_upper <- (n-1)*var_x/qchisq(1-0.025, df=n-1, lower.tail=FALSE)
  if (CI_lower<(1/lambda^2) & CI_upper>(1/lambda^2)) counter <- counter+1
} 
counter/nsim

# Compute asymptotic CI:
library(e1071)  # We use the kurtosis() function from package e1071.
set.seed(19680912)
n <- 20
lambda <- 0.5
nsim <- 10000
counter <- 0
for (i in 1:nsim) {
  x <- rexp(n, rate=0.5)
  var_x <- var(x)
  b2 <- kurtosis(x, type=3)
  SE <- var_x*sqrt((b2+2)/n)
  CI_lower <- var_x - qnorm(1-0.025, mean=0, sd=1)*SE
  CI_upper <- var_x + qnorm(1-0.025, mean=0, sd=1)*SE
  if (CI_lower<(1/lambda^2) & CI_upper>(1/lambda^2)) counter <- counter+1
} 
counter/nsim




########## Problem 5.6

### 2.
high_school <- read.csv("high-school.csv")
new_data <- high_school[high_school$SPORTS>0, ]
n <- nrow(new_data)
xbar  <- mean(new_data$SPORTS)
s2 <- (n-1)*var(new_data$SPORTS)/n
alphatilde <- xbar^2/s2
betatilde <- xbar/s2
alphatilde
betatilde


### 3.
# Using the function mle() from the package stats4:
library(stats4)
minuslogl <- function(alpha, beta) {
  densities <- dgamma(new_data$SPORTS, shape=alpha, rate=beta)
  -sum(log(densities))
}
mle(minuslogl, start=list(alpha=1, beta=0.5), method="L-BFGS-B", lower=c(0, 0))

# Using the function fitdistr() from the package MASS:
library(MASS)
fitdistr(new_data$SPORTS, densfun="gamma", start=list(shape=1, rate=0.5), lower=c(0, 0))


### 4.
nsim <- 100  # Number of simulations.
m <- 1000  # Number of children.
mle_est <- matrix(NA, nrow=nsim, ncol=2)
mme_alpha <- rep(NA, times=nsim)
mme_beta <- rep(NA, times=nsim)

set.seed(3746347)
for (i in 1:nsim) {
  new_data$id <- 1:nrow(new_data)  # Create id variable.
  sample_id <- sample(new_data$id, size=m, replace=FALSE)
  x <- new_data[sample_id, "SPORTS"]
  mle_sport <- fitdistr(x, densfun="gamma", start=list(shape=1, rate=0.5), lower=c(0, 0))
  mle_est[i, ] <- coef(mle_sport)  # Store the MLE for each sample.
  xbar  <- mean(x)
  s2 <- (m-1)*var(x)/m
  mme_alpha[i] <- xbar^2/s2
  mme_beta[i]  <- xbar/s2
}

c(mean(mle_est[, 1]), var(mle_est[, 1]))
c(mean(mle_est[, 2]), var(mle_est[, 2]))
c(mean(mme_alpha), var(mme_alpha))
c(mean(mme_beta), var(mme_beta))

mean(mle_est[, 1])/mean(mle_est[, 2])
mean(mme_alpha)/mean(mme_beta)
