########## Problem 6.1


### 1.
voting <- read.csv("voting-demo.csv")
tab <- table(voting$Vote, voting$Choice)
margtab <- addmargins(tab)
margtab


### 2.
# Calculate chi squared:
chi2 <- unname(chisq.test(tab)$statistic)
chi2
# Calculate Phi:
n <- sum(tab)  # Calculate sample size.
Phi <- sqrt(chi2/n)
Phi
# Calculate Cramer's V:
t <- min(nrow(tab)-1, ncol(tab)-1)
V <- sqrt(chi2/(n*t))
V

# cell_ij is the cell in row i and column j:
cell_11 <- (102 - 332 * 246 / 748)^2 / (332 * 246 / 748)
cell_12 <- (45  - 131 * 246 / 748)^2 / (131 * 246 / 748)
cell_13 <- (99  - 285 * 246 / 748)^2 / (285 * 246 / 748)
cell_21 <- (230 - 332 * 502 / 748)^2 / (332 * 502 / 748)
cell_22 <- (86  - 131 * 502 / 748)^2 / (131 * 502 / 748)
cell_23 <- (186 - 285 * 502 / 748)^2 / (285 * 502 / 748)
chi2 <- cell_11 + cell_12 + cell_13 + cell_21 + cell_22 + cell_23
chi2


### 3.
barplot(tab, legend.text=rownames(tab), beside=TRUE, xlab="Choice", ylab="Number of persons")


### 5.
Age <- voting$Age
Age2 <- 12*Age
plot(Age, Age2)
cor(Age, Age2, use="complete.obs")


### 6.
noise <- function(x) {
  Age2 <- Age2 + rnorm(length(Age2), mean=0, sd=x)
  plot(Age, Age2)
  cor(Age, Age2, use="complete.obs")
}

set.seed(5710)
noise(1)
noise(10)
noise(100)




########## Problem 6.3

### 1.
set.seed(85276)
x <- rnorm(10^5, mean=0, sd=1)
y <- x^2
cov(x, y)
cor(x, y)


### 3.

# Fit the linear regression model:
M1 <- lm(Age ~ Church, data=voting)

# Obtain the R-squared and the association indicator:
rsquared <- summary(M1)$r.squared
assocind <- sqrt(rsquared)
assocind

# Place the education factor levels in the correct order:
levels(voting$Educ)
voting$Educ <- factor(voting$Educ, levels(voting$Educ)[c(4, 1, 2, 3)], ordered=TRUE)
levels(voting$Educ)

# Fit the linear regression model:
M2 <- lm(Age ~ Educ, data=voting)

# Obtain the R-squared and the association indicator:
rsquared <- summary(M2)$r.squared
assocind <- sqrt(rsquared)
assocind

library(Hmisc)
rho <- rcorr(voting$Educ, voting$Age, type="spearman")
rho$r




########## Problem 6.4


# Generate two predictors x1 and x2:
set.seed(2095)
n <- 1000  # Number of observations.
x1 <- runif(n, min=-10, max=10)
x2 <- rnorm(n, mean=10, sd=10)

# Specify the regression coefficients and the standard deviation of the error term (these should be changed in order to answer the questions below):
beta0 <- 10
beta1 <- 0
beta2 <- 0.5
beta3 <- 0
err <- 10

# Generate outcome data y:
y <- beta0 + beta1*x1 + beta2*x2 + beta3*x1*x2 + rnorm(n, mean=0, sd=err)

# Analyze the data:
cor(y, x1)
cor(y, x2)
M1 <- lm(y ~ x1 + x2 + x1*x2)
summary(M1)


### 1.
# Generate two predictors x1 and x2:
set.seed(2095)
n <- 1000  # Number of observations.
x1 <- runif(n, min=-10, max=10)
x2 <- rnorm(n, mean=10, sd=10)

# Specify the regression coefficients and the standard deviation of the error term:
beta0 <- 0
beta1 <- 0
beta2 <- 0.8
beta3 <- 0
err <- 6

# Generate outcome data y:
y <- beta0 + beta1*x1 + beta2*x2 + beta3*x1*x2 + rnorm(n, mean=0, sd=err)

# Compute the correlation between y and x2:
cor(y, x2)


### 2.
# Generate two predictors x1 and x2:
set.seed(2095)
n <- 1000  # Number of observations.
x1 <- runif(n, min=-10, max=10)
x2 <- rnorm(n, mean=10, sd=10)

# Specify the regression coefficients and the standard deviation of the error term:
beta0 <- 0
beta1 <- 0
beta2 <- 5
beta3 <- 0
err <- 0.1

# Generate outcome data y:
y <- beta0 + beta1*x1 + beta2*x2 + beta3*x1*x2 + rnorm(n, mean=0, sd=err)

# Estimate the regression coefficients:
M2 <- lm(y ~ x1 + x2 + x1*x2)
round(coef(M2), 3)


### 3.
# Generate predictors
n <- 100
x1 <- runif(n, -10, 10)
x2 <- rnorm(n, 10, 10)

### the coefficient
b0 <- 10
b1 <- 10
b2 <- 10
b3 <- 10
err <- 0.1
###

# the model
summary(y <- b0 + b1 * x1 + b2 * x2 + b3 * x1 * x2 + rnorm(100, 0, err))

# inspect the model
model1 <- lm(y ~ x1 + x2 + x1 * x2)
summary(model1)


### 4.
# Generate two predictors x1 and x2:
set.seed(2095)
n <- 1000  # Number of observations.
x1 <- runif(n, min=-10, max=10)
x2 <- rnorm(n, mean=10, sd=10)

# Specify the regression coefficients and the standard deviation of the error term:
beta0 <- 0
beta1 <- 0
beta2 <- 0
beta3 <- 0
err <- sqrt(10^6)

# Generate outcome data y:
y <- beta0 + beta1*x1 + beta2*x2 + beta3*x1*x2 + rnorm(n, mean=0, sd=err)

# Compute the mean squared error:
M3 <- lm(y ~ x1 + x2 + x1*x2)
mse <- mean(M3$residuals^2)
mse
